=== .github/requirements.txt ===
setuptools
boto3
requests
twine
tomli
mako
wheel
