=== api/c/ELF/CMakeLists.txt ===
target_sources(LIB_LIEF PRIVATE
  Symbol.cpp
  Section.cpp
  Segment.cpp
  DynamicEntry.cpp
  Header.cpp
  Binary.cpp
  utils.cpp
)
